function selectWord(en, fr) {
    switch (LANG) {
        case 'fr':
            return fr;
        default:
            return en;
    }
}

function newGame(father) {
    if (father.scene.getIndex('Game') !== -1) {
        father.scene.remove('Game');
    }
    father.scene.add('Game', new Game(father));
}

function chooseTarget(robot, list) {
    let minDist = WIDTH_MAP * 2;
    let l = [];
    list.forEach(function (item) {
        if (item !== robot) {
            let hypot = Math.hypot(item.x - robot.x, item.y - robot.y);
            if (minDist >= hypot) {
                if (minDist > hypot) {
                    minDist = hypot;
                    l = [];
                }
                l.push(item);
            }
        }
    });
    if (l.length > 1) {
        return l[Math.floor(Math.random() * (l.length + 1))];
    } else {
        return l[0];
    }
}


var listBonus = [];
var LANG = navigator.language.substr(0, 2).toLowerCase();
const MYSELF = 'myself';
const SHIELD_PER_SECOND = 5;
const COLOR_ATTACK = 0xff0000;
const COLOR_MOVE = 0x0000ff;
const COLOR_CONDITION = 0x0e0e0e;
const DURATION_DAMAGE = 700;
const WIDTH_WINDOW = $(document).width() - 20;
const HEIGHT_WINDOW = $(document).height() - 20;
const WIDTH_MAP = WIDTH_WINDOW < HEIGHT_WINDOW ? WIDTH_WINDOW * 0.8 : HEIGHT_WINDOW * 0.8;
const SPEED = 2;
const LIFE = 100;
const DAMAGE = 40;
const SHIELD = 100;
const RANGE = WIDTH_MAP / 2;


var config = {
    type: Phaser.AUTO,
    width: WIDTH_WINDOW,
    height: HEIGHT_WINDOW,
    parent: 'all',
    backgroundColor: '#35363A',
};

let father = new Phaser.Game(config);

father.scene.add('Boot', new Boot(father));
father.scene.start('Boot');
