class GamingBoard extends Phaser.Scene {
    constructor(father) {
        super('GamingBoard');
        this.listRobot = [];
        listBonus = [];
        this.father = father;
        this.end = false;
    }

    preload() {
        this.cameras.main.setViewport(WIDTH_WINDOW / 10, HEIGHT_WINDOW / 10, WIDTH_MAP, WIDTH_MAP);
        this.sound.add('shot');
        this.sound.add('hit');
    }

    create() {
        listBonus.push(new BonusSpeed('Balle Argent', this, WIDTH_MAP / 2, WIDTH_MAP / 2, 3, 2000));

        this.add.image(0, 0, 'background').alpha = 0.1;

        for (let i = 0; i < this.listRobot.length; i++) {
            this.listRobot[i].setTarget(chooseTarget(this.listRobot[i], this.listRobot));
        }

        this.listRobot[0].drawRange();

        this.events.on('resume', () => this.resume());

        this.time.addEvent({delay: 2000, callback: this.upShield, callbackScope: this});
    }

    update(time, delta) {
        super.update(time, delta);
        this.listRobot.forEach(function (robot) {
            robot.read();
        })

        for (let i = 0; i < this.listRobot.length; i++) {
            if (!this.listRobot[i].isAlive()) {
                this.listRobot.splice(i, 1);
                i -= 1;
            } else {
                if (!this.listRobot[i].haveTarget()) {
                    this.listRobot[i].setTarget(chooseTarget(this.listRobot[i], this.listRobot));
                }
            }
        }

        if (this.listRobot.length <= 1 && !this.end) {
            this.end = true;
            this.time.addEvent({delay: 1000, callback: this.finish, callbackScope: this});
        }
    }

    finish() {
        this.pause();
        this.father.finish();
    }

    winner() {
        return this.listRobot.length !== 0 && this.listRobot[0].name === 'myself';
    }

    pause() {
        this.scene.pause('GamingBoard');
        this.sound.pauseAll();
    }

    resume() {
        this.scene.resume('GamingBoard');
        this.sound.resumeAll();
    }

    addRobot(robot) {
        this.listRobot.push(robot);
    }

    modifyNodes(lNodes) {
        for (let i = 0; i < this.listRobot.length; i++) {
            if (this.listRobot[i].name === MYSELF) {
                this.listRobot[i].cleanNodes();
                lNodes.forEach(element => this.listRobot[0].addNode(element));
                return true;
            }
        }
        return false;
    }


    upShield() {
        this.listRobot.forEach(robot => robot.addShield(SHIELD_PER_SECOND));
        this.time.addEvent({delay: 1000, callback: this.upShield, callbackScope: this});
    }

}